---------------------
-- Library calling --
---------------------
--Call the ACE Libraries
MBPNsearch = LibStub("AceGUI-3.0")
--local AceGUI = LibStub("AceGUI-3.0")
MBPNCsearch = LibStub("AceConsole-3.0")
LibStub("AceEvent-3.0"):Embed(MBPNCsearch)

-------------------------------------------------------------------------------
----------------------
-- local definitons --
----------------------
MBPNframe = MBPNframe

local pointsDB = pointsDB or {}
local points = points or {}
local worldmap = worldmap or {}

function MBPNinitializePoints()
   points = CreateFrame("Frame", "overlayPoints", WorldMapButton)
   worldmap = CreateFrame("Button", nil, overlayPoints)
   worldmap:SetHeight(12)
   worldmap:SetWidth(12)
   worldmap:RegisterForClicks("RightButtonUp")
   worldmap.icon = worldmap:CreateTexture("ARTWORK")
   worldmap.icon:SetAllPoints()
   worldmap.icon:SetTexture("Interface\\AddOns\\TomTom\\Images\\GoldGreenDot")
end



function AddZoneWaypoints(continentID,zoneID,creatureName)
   MBPNinitializePoints()
   if not TomTom then return end
   TomTom:ClearAllWaypoints()
   local pb = _G.petBattles
   if not pb then return end
   for i = 1,# pb do
      local xPos=tonumber(pb[i].loc.x)
      local yPos=tonumber(pb[i].loc.y)
      if pb[i].continentid == continentID and pb[i].zoneid == zoneID then
         for j=1,# pb[i].pets.pet do
            if pb[i].pets.pet[j].name == creatureName then 
               --print("point added",xPos,yPos)
               --(continentID,zoneID,xPos(0-1),yPos(0-1),persist,Minimap,Worldmap,callbacks,silent,crazy)
               TomTom:AddZWaypoint(continentID,zoneID,xPos,yPos,creatureName,true,Minimap,worldmap,nil,true,false)
            end
         end
      end
      
   end
end

function testPoints()
   local continentID = GetCurrentMapContinent()
   local zoneID = GetCurrentMapZone()
   local unitX, unitY = GetPlayerMapPosition("player")
   unitX=tonumber(strsub(unitX,0,6))*100
   unitY=tonumber(strsub(unitY,0,6))*100
end



-------------------------------------------------------------------------------
-----------------------
-- tree group select --
-----------------------

local function CreateSearchTab(container)
   local filter = {
      ["Name"] = true,
      ["Source"] = false,
      ["Description"] = false,
      ["Ability"] = false,
   }
   
   function PetFinder(search)
      local x={};
      local text = ""
      local labels = {}
      local count = 1
      local rarityfilter = -1
      local p = C_PetJournal;
      p.AddAllPetSourcesFilter(true)
      p.AddAllPetTypesFilter(true)
      p.ClearSearchFilter(true)
      local n = "|n"
      for i=1,p.GetNumPets(false) do 
         local label = MBPNsearch:Create("InteractiveLabel")
         label:SetFullWidth(true)
         id,_,_,_,l,_,_,nm,ic,_,_,d=p.GetPetInfoByIndex(i);
         if id then id = tonumber(id) end
         if string.find(strlower(nm), strlower(search)) and not x[nm] then 
            if id>0 then 
               name, customName, level, xp, maxXp, sourceText, description, health, maxHealth, rarity = GetPetInfoByID(id)
               sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
               
               cName = ""
               if name ~= customName then cName = " ("..customName..")" end
               label:SetText(p.GetBattlePetLink(id)..cName.." (L"..l..")"..n..sourceText..n..d..n..n)
               label:SetImage(ic)
               label:SetImageSize(64,64)
            else 
               label:SetText(nm..n..d..n..n)
               x[nm]=1;
            end 
            labels[count] = label
            count = count + 1
         end 
      end
      return labels
   end
   searchScrollGroup = MBPNsearch:Create("ScrollFrame")
   searchGroup = MBPNsearch:Create("SimpleGroup")
   searchButton = MBPNsearch:Create("Button")
   searchGroup:SetLayout("Flow")
   editbox = MBPNsearch:Create("EditBox")
   editbox:SetLabel("Keyword Search")
   local rarityDropdown = MBPNsearch:Create("Dropdown")
   local filterDropdown = MBPNsearch:Create("Dropdown")
   local rarityList = {color["grey"].."Poor|r",color["white"].."Common|r",color["green"].."Uncommon|r",color["blue"].."Rare|r",color["purple"].."Epic|r",color["red"].."Undefined|r","All"}
   rarityDropdown:SetList(rarityList)
   rarityDropdown:SetLabel("Rarity")
   rarityDropdown:SetValue(7)
   filterDropdown:SetList({"Name","Source","Description","Ability"})
   filterDropdown:SetMultiselect(true)
   filterDropdown:SetLabel("Filters")
   filterDropdown:SetValue(1)
   rarityfilter = -1
   function EditBoxEnterPressed(_,_,text)
      local search = text
      searchScrollGroup:ReleaseChildren()
      local heading = MBPNsearch:Create("Heading")
      heading:SetFullWidth(true)
      heading:SetText("Searching for '"..text.."'")
      local label1 = MBPNsearch:Create("Label")
      label1:SetText(" ")
      searchScrollGroup:AddChild(heading)
      if not search then search = "" end
      if  strlen(search) < 2 then print("Please use at least 2 characters when searching") return end
      local pets = PetDownloader
      local abilities = {}
      local s = strlower(search) or ""
      local function runSearch()
         for i=1,#pets["index"] do
            local found = false
            local idx = pets["index"][i]
            local name = pets["name"][i] or " "
            if pets[name] then
               local src = pets["sourcetext"][i] or " "
               local des = pets["petdesc"][i] or " "
               local source = strlower(src) or " "
               local desc = strlower(des) or " "
               local name = strlower(name) or " "
               if filter["Name"] == true then 
                  if string.find(name,s) then
                     found = true 
                  end
               end
               if filter["Source"] == true then 
                  if string.find(source,s) then
                     found = true 
                  end
               end
               if filter["Description"] == true then 
                  if string.find(desc,s) then
                     found = true 
                  end
               end
               if not pets["rarity"][i] then pets["rarity"][i] = 0 end
               
               if found == true and rarityfilter == 7 then rarityfilter = -1 end
               if found == true and rarityfilter > pets["rarity"][i] then found = false end
               
               --for j=1,6 do
               --local abtext = pets["petabilitytext"][idx][j] or " "
               --local abt = strlower(abtext) or " "
               --local abname = pets["petabilityname"][idx][j] or " "
               --local abn = strlower(abname) or " "
               --if string.find(abt,s) and filter["abilitytext"] then found = true end
               --if string.find(abn,s) and filter["abilityname"] then found = true end
               --end
               if found == true then
                  local level = pets["level"][i]
                  local petname = pets["link"][i]
                  if  petname == 0 then petname = pets["name"][i] end
                  local levelText = ""
                  local link = ""
                  if level > 0 then levelText = " (L"..level..") " 
                  else
                     levelText = " (Not Owned)"
                  end
                  local searchFindHeader = MBPNsearch:Create("Heading")
                  searchFindHeader:SetFullWidth(true)
                  searchFindHeader:SetText(petname..levelText)
                  local searchFindLabel1 = MBPNsearch:Create("InteractiveLabel")
                  searchFindLabel1:SetFullWidth(true)
                  searchFindLabel1:SetText(pets["sourcetext"][i])
                  searchFindLabel1:SetImage(pets["peticon"][i])
                  searchFindLabel1:SetImageSize(48,48)
                  local searchFindLabel2 = MBPNsearch:Create("InteractiveLabel")
                  searchFindLabel2:SetFullWidth(true)
                  searchFindLabel2:SetText(pets["petdesc"][i])
                  searchScrollGroup:AddChild(searchFindHeader)
                  searchScrollGroup:AddChild(searchFindLabel1)
                  searchScrollGroup:AddChild(searchFindLabel2)
                  --searchGroup:AddChild(searchFindHeader)
                  --searchGroup:AddChild(searchFindLabel1)
                  --searchGroup:AddChild(searchFindLabel2)
                  --local inlineGroup = MBPNsearch:Create("InlineGroup")
                  --inlineGroup:SetFullWidth(true)
                  --inlineGroup:SetTitle("Abilities")
                  --for num=1,6 do 
                  --   local abilname = pets["petabilityname"][i][num]
                  --   local abilframe = pets["petabilityid"][abilname] or {}
                  --   if not abilframe then 
                  --      MBPNsearch:Create("InteractiveLabel")
                  --      abilframe:SetFullWidth(true)
                  --      abilframe:SetImage(pets["petabilityicon"][i][num])
                  --   else
                  --   end 
                  --   inlineGroup:AddChild(abilframe)
                  --end
                  --searchScrollGroup:AddChild(inlineGroup)
               end
            end
         end
      end
      runSearch()
   end
   
   local function filterChanged(self,event,key,checked)
      local k = {"Name","Source","Description","Ability"}
      filter[k[key]] = checked
      EditBoxEnterPressed(_,_,editbox:GetText())
   end
   local function rarityChanged(self,event,key)
      rarityfilter = key
      EditBoxEnterPressed(_,_,editbox:GetText())
   end
   local function GoButton()
      EditBoxEnterPressed(_,_,editbox:GetText())
   end
   
   filterDropdown:SetItemValue(1,filter["Name"])
   filterDropdown:SetItemValue(2,filter["Source"])
   filterDropdown:SetItemValue(3,filter["Desription"])
   filterDropdown:SetItemValue(4,filter["Ability"])
   --filterDropdown:SetText("Name")
   filterDropdown:SetCallback("OnValueChanged",filterChanged)
   rarityDropdown:SetCallback("OnValueChanged",rarityChanged)
   searchButton:SetCallback("OnClick",GoButton)
   searchGroup:SetFullWidth(true)
   searchScrollGroup:SetFullWidth(true)
   searchGroup:SetFullHeight(true)
   searchButton:SetText("Go")
   searchScrollGroup:SetFullHeight(true)
   editbox:SetRelativeWidth(0.35)
   searchButton:SetRelativeWidth(0.15)
   rarityDropdown:SetRelativeWidth(0.25)
   filterDropdown:SetRelativeWidth(0.25)
   editbox:SetCallback("OnEnterPressed",EditBoxEnterPressed)
   searchGroup:AddChild(editbox)
   searchGroup:AddChild(searchButton)
   searchGroup:AddChild(rarityDropdown)
   searchGroup:AddChild(filterDropdown)
   searchGroup:AddChild(searchScrollGroup)
   container:AddChild(searchGroup)
end

-------------------------------------------------------------------------------
-----------------------
-- tree group select --
-----------------------

local function TreeGroupHandler(container)
   
   function TreeGroupSelected(group,event,node)
      
      local petLink = petLink
      function ShowContinentInfo(c)
         text = c
         return text
      end
      
      function ShowPetsInZone(z)
         local pets = SearchZoneForPets(z)
         local min, max = GetZoneLevelByName(z)
         local n = "|n"
         local text = ""
         for i=1, # pets do
            pet = pets[i]
            local name = pet["name"]
            local level = pet["level"]
            local customName = pet["customName"]
            local rarity = pet["rarity"]
            if level ~= nil then
               text = text..rarityColor[rarity]..name.."|r (L"..level..")"..n
            end
         end
         return text
      end
      
      function ShowPetTypeInfo(t)
         local text = ""--rarityColor[0].."No pets found in this zone!"
         for i=1,C_PetJournal.GetNumPets(false) do
            local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(i)
            sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
            if name == t then
               text = ""
               local n = "|n"
               text = text.."Creature Type: "..name..n..n
               text = text.."Source: "..sourceText..n..n
               text = text.."Description: "..description
            end
         end
         return text
      end
      
      function ShowMyPetInfo(m,t)
         local speciesID, customName, level, xp, maxXp, displayID, name, icon, petType, creatureID, sourceText, description, isWild, canBattle,tradable, unique = C_PetJournal.GetPetInfoByPetID(m)
         local health, maxHealth, attack, speed, rarity = p.GetPetStats(m)
         sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
         
         local link = ""
         local text = ""
         local n = "|n"
         if customName ~= nil then
            text = text.."Custom Name: "..customName..n..n
         end
         text = text.."Creature Type: "..t..n..n
         text = text.."Pet ID: "..m..n..n
         text = text.."Level: "..level..n..n
         text = text.."XP: "..xp.."/"..maxXp..n..n
         text = text.."Source: "..sourceText..n..n
         text = text.."Desciption: "..description..n..n
         if tradable then
            text = text.."Tradable: Yes"..n..n
         else
            text = text.."Tradable: No"..n..n
         end
         text = text.."Health: "..health.."/"..maxHealth..n..n
         text = text.."Attack "..attack..n..n
         text = text.."Speed: "..speed..n..n
         r = {
            [0] = rarityColor[0].."Unknown|r",
            [1] = rarityColor[1].."Poor|r",
            [2] = rarityColor[2].."Common|r",
            [3] = rarityColor[3].."Uncommon|r",
            [4] = rarityColor[4].."Rare|r",
            [5] = rarityColor[5].."Epic|r"
         }
         text = text.."Rarity: "..r[rarity]
         return text,name,link,level,icon,speciesID
      end
      function OnIconClick(frame,event,button)
         print(frame,event,button)
         iframe = GetClickFrame(frame)
         iframe:Show()
      end
      
      treeScrollFrame:ReleaseChildren()
      local c, z, t, m = strsplit("\001",node,4)
      local pets={{}}
      local label1 = MBPNsearch:Create("InteractiveLabel")
      local label2 = MBPNsearch:Create("InteractiveLabel")
      local label3 = MBPNsearch:Create("InteractiveLabel")
      local header = MBPNsearch:Create("Heading")
      header:SetText(" ")
      label1:SetText(" ")
      label2:SetText(" ")
      label3:SetText(" ")
      header:SetFullWidth(true)
      label1:SetFullWidth(true)
      label2:SetFullWidth(true)
      label3:SetFullWidth(true)
      local abilityGroup = MBPNsearch:Create("SimpleGroup")
      local min, max
      if z ~= nil then
         pets = SearchZoneForPets(z)
         if pets ~= nil and # pets > 0 then
         end
         min, max = GetZoneLevelByName(z)
      end
      if m ~= nil then
         petID = tonumber(m)
         text, name,link,level, icon, speciesID = ShowMyPetInfo(m,t)
         abilityGroup:SetFullWidth(true)
         abilityGroup:SetFullHeight(true)
         petIndex = PetDownloader[t]
         abilityGroup:ReleaseChildren()
         for abs=1,6 do
            local abil = PetDownloader["petability"][petIndex][abs]
            local aName = PetDownloader["petabilityname"][petIndex][abs]
            local aText = PetDownloader["petabilitytext"][petIndex][abs]
            local aIcon = PetDownloader["petabilityicon"][petIndex][abs]
            local a1 = MBPNsearch:Create("InteractiveLabel")
            a1:SetFullWidth(true)
            a1:SetText(" ")
            a1:SetText(aText)
            a1:SetImage(aIcon)
            a1:SetImageSize(48,48)
            local ah = MBPNsearch:Create("Heading")
            ah:SetFullWidth(true)
            ah:SetText(" ")
            ah:SetText(aName)
            abilityGroup:AddChild(ah)
            abilityGroup:AddChild(a1)
         end         
         name = "(L"..level..") "..name
         label1:SetText(text)
         header:SetText(name)
         ic = MBPNsearch:Create("Icon")
         ic:SetCallback("OnIconClick",OnIconClick)
         petLink = link
         ic:SetImage(icon)
         ic:SetImageSize(72,72)
         treeScrollFrame:AddChild(header)
         treeScrollFrame:AddChild(ic)
         treeScrollFrame:AddChild(label1)
         treeScrollFrame:AddChild(abilityGroup)
         
      elseif t ~= nil then
         petIndex = PetDownloader[t]
         abilityGroup:SetFullWidth(true)
         abilityGroup:SetFullHeight(true)
         abilityGroup:ReleaseChildren()
         function PlotPoints(continent,zone,type)
            --print("test!!",c,z,t,m)
            local continents = {GetMapContinents()}
            local continentID = 0
            for idx=1,# continents do
               if continent==continents[idx] then continentID=idx end
            end
            if continentID == 0 then return end
            local zones = {GetMapZones(continentID)}
            local zoneID = 0
            for idx=1,# zones do 
               if zones[idx]==zone then zoneID=idx end
            end
            if zoneID == 0 then return end
            AddZoneWaypoints(continentID,zoneID,type)
         end
         PlotPoints(c,z,t)
         for abs=1,6 do
            local abil = PetDownloader["petability"][petIndex][abs]
            local aName = PetDownloader["petabilityname"][petIndex][abs]
            local aText = PetDownloader["petabilitytext"][petIndex][abs]
            local aIcon = PetDownloader["petabilityicon"][petIndex][abs]
            
            local a1 = MBPNsearch:Create("InteractiveLabel")
            a1:SetFullWidth(true)
            a1:SetText(" ")
            a1:SetText(aText)
            a1:SetImage(aIcon)
            a1:SetImageSize(48,48)
            local ah = MBPNsearch:Create("Heading")
            ah:SetFullWidth(true)
            ah:SetText(" ")
            ah:SetText(aName)
            abilityGroup:AddChild(ah)
            abilityGroup:AddChild(a1)
            --abilityGroup:AddChild(myPetButton)
         end         
         
         header:SetText("Pet Type: "..t)
         label2:SetText(ShowPetTypeInfo(t))
         treeScrollFrame:AddChild(header)
         treeScrollFrame:AddChild(label2)
         treeScrollFrame:AddChild(abilityGroup)
      elseif z ~= nil then
         header:SetText("Zone: "..z)
         label3:SetText(ShowPetsInZone(z))
         treeScrollFrame:AddChild(header)
         treeScrollFrame:AddChild(label3)
         treeScrollFrame:AddChild(abilityGroup)
      elseif c ~= nil then
         header:SetText(ShowContinentInfo(c))
         treeScrollFrame:AddChild(header)
      end
   end
   
   local tree = ZoneTree
   treeGroup = MBPNsearch:Create("TreeGroup")
   treeGroup:SetFullWidth(true)
   treeGroup:SetFullHeight(true)
   treeGroup:SetCallback("OnGroupSelected",TreeGroupSelected)
   treeGroup:SetTree(tree)
   treeGroup:SetFullWidth(true)
   treeGroup:SetFullHeight(true)
   treeGroup:EnableButtonTooltips(false)
   treeScrollFrame = MBPNsearch:Create("ScrollFrame")
   treeScrollFrame:SetFullWidth(true)
   treeScrollFrame:SetFullHeight(true)
   treeGroup:AddChild(treeScrollFrame)
   container:AddChild(treeGroup)
   local continentID = GetCurrentMapContinent()
   local continent = GetContinentByID(continentID)
   local zoneID = GetCurrentMapZone()
   local zone = GetZoneByID(continentID,zoneID)
   local defaultTree = continent.."\001"..zone
   treeGroup:SelectByPath(defaultTree)
end

-------------------------------
-- handler for tab selection --
-------------------------------


local function SelectTabGroup(container,event,group)
   container:ReleaseChildren()
   if group=="searchGroup" then
      CreateSearchTab(container)
   end
   if group=="browseGroup" then
      TreeGroupHandler(container)
   end
end

-------------------------------
-- handler for command /pets --
-------------------------------

function MBPNCsearch:MBPNsearchWindow(msg)
   PetDownloader_Download()
   if not msg then msg = "" end
   if not MBPNframe or strlower(msg) == "reset" then
      MBPNframe = MBPNsearch:Create("Window")
      MBPNframe:SetTitle("My Pet Battle Notifier")
      --MBPNframe:SetClampedToScreen(true)
      MBPNframe:SetWidth(450)
      MBPNframe:SetHeight(500)
      MBPNframe:SetPoint("RIGHT",nil,"RIGHT")
      MBPNframe:SetLayout("Fill")
      MBPNframe:SetCallback("OnClose",function(widget) MBPNframe:Hide() end)
      
      tabGroup = MBPNsearch:Create("TabGroup")
      tabGroup:SetFullWidth(true)
      tabGroup:SetFullHeight(true)
      tabGroup:SetLayout("Flow")
      tabGroup:SetTabs({
            {text="Browse",value="browseGroup"},
            {text="Search",value="searchGroup"},
            --{text="Journal",value="journalGroup"},
      })
      tabGroup:SetCallback("OnGroupSelected",SelectTabGroup)
      MBPNframe:AddChild(tabGroup)
      tabGroup:SelectTab("browseGroup")
   else
      if MBPNframe:IsVisible() then 
         MBPNframe:Hide()
         PlaySound("igCharacterInfoClose")
      else
         MBPNframe:Show()
         PlaySound("igCharacterInfoOpen")
      end
   end
end
------------------------------------------
-- Events and slash command registering --
------------------------------------------


MBPNCsearch:RegisterChatCommand("pets", "MBPNsearchWindow")
