local MBPNtally = LibStub("AceGUI-3.0")
local MBPNCtally = LibStub("AceConsole-3.0")
tallyWindow = MBPNtally:Create("Window")
tallyWindow:Hide()
tallyWindow:SetWidth(200)
tallyWindow:SetHeight(175)
tallyWindow:EnableResize(false)
tallyWindow:SetPoint("TOPLEFT",nil,"TOPLEFT")
tallyWindow:SetTitle("MBPN Tally")
tallyWindow:SetCallback("OnClose",function() tallyWindow:Hide() end)
local tallyLabels = {}
for i=1,13 do 
   tallyLabels[i] = MBPNtally:Create("InteractiveLabel")
   tallyLabels[i]:SetFullWidth(true)
   tallyLabels[i]:SetText(" ")
   tallyWindow:AddChild(tallyLabels[i])
end
tallyLabels[3]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("all unowned") end)
tallyLabels[5]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("all nonrare") end)
tallyLabels[6]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("all rare") end)
tallyLabels[7]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("all nonswithrares") end)

tallyLabels[9]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("battle unowned") end)
tallyLabels[11]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("battle nonrare") end)
tallyLabels[12]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("battle rare") end)
tallyLabels[13]:SetCallback("OnClick",function() MBPNCtally:PrintTotals("battle nonswithrares") end)
function MBPNCtally:PrintTotals(msg)
   tallyWindow:Show()
   local p=C_PetJournal
   local highest = {}
   local lowest = {}
   local battlePetHighest = {}
   local battlePetLowest = {}
   local owned = {}
   local unowned = {}
   local battlePetOwned = {}
   local unownedName = {}
   local unownedBattlePetName = {}
   local ownedName = {}
   local battlePetOwnedName = {}
   local battlePetLinks = {}
   local allLinks = {}
   local totalCount = 0
   local ownedCount = 0
   local battlePetOwnedCount = 0
   local unownedCount = 0
   local petBattleUnowned = 0
   local nonRare=0
   local onlyRare=0
   local nonRareWithRare=0
   local battlePetNonRareWithRare=0
   local battlePetOnlyRare=0
   local battlePetNonRare=0
   local color = { 
      [0] = "|cffff0000",
      [1] = "|cFF8f8f8f",
      [2] = "|cFFffffff",
      [3] = "|cFF00ff00",
      [4] = "|cFF0080ff",
      [5] = "|cFF9482C9",
      ["red"] = "|cffff0000",
      ["grey"] = "|cFF8f8f8f",
      ["white"] = "|cFFffffff",
      ["green"] = "|cFF00ff00",
      ["blue"] = "|cFF0080ff",
      ["purple"] = "|cFF9482C9"
   }
   local function GetTotals()
      totalCount = 0
      for i=1,# PetDownloader do 
         local petID = PetDownloader["petid"][i]
         local rarity= PetDownloader["rarity"][i]
         local lnk   = PetDownloader["link"][i]
         local sourceText= PetDownloader["sourcetext"][i] or ""
         if not petID then petID=0 else petID=tonumber(petID) end
         if petID>0 then 
            local petBattle=false
            totalCount=totalCount+1
            if string.find(sourceText,"Pet Battle") then
               petBattle=true
            end
            
            if not owned[name] then 
               owned[name]=1
               ownedCount=ownedCount+1
               ownedName[ownedCount]=name
               allLinks[name]=lnk
               allLinks[battlePetOwnedCount]=lnk
            else 
               owned[name] = owned[name]+1
               allLinks[name]=lnk
               allLinks[battlePetOwnedCount]=lnk
            end
            if petBattle==true then 
               if not battlePetOwned[name] then 
                  battlePetOwned[name]=1
                  battlePetOwnedCount=battlePetOwnedCount+1
                  battlePetOwnedName[battlePetOwnedCount]=name 
                  battlePetLinks[name]=lnk
                  battlePetLinks[battlePetOwnedCount]=lnk
               else
                  battlePetOwned[name] = battlePetOwned[name]+1
                  battlePetLinks[name]=lnk
                  battlePetLinks[battlePetOwnedCount]=lnk
               end
               if not battlePetLowest[name] then 
                  battlePetLowest[name]=rarity 
               else 
                  if rarity<battlePetLowest[name] then 
                     battlePetLowest[name]=rarity 
                  end
               end
               if not battlePetHighest[name] then 
                  battlePetHighest[name]=rarity 
               else 
                  if rarity>battlePetHighest[name] then 
                     battlePetHighest[name]=rarity 
                  end
               end
            end
            if not lowest[name] then 
               lowest[name]=rarity 
            else 
               if rarity<lowest[name] then 
                  lowest[name]=rarity 
               end
            end
            if not highest[name] then 
               highest[name]=rarity 
            else 
               if rarity>highest[name] then 
                  highest[name]=rarity 
               end
            end
         else
            unowned[name]=1
            unownedCount=unownedCount+1
            unownedName[unownedCount]=name
            lowest[name]=0
            highest[name]=0
            if string.find(sourceText,"Pet Battle") then
               petBattleUnowned=petBattleUnowned+1
               unownedBattlePetName[petBattleUnowned]=name
            end
         end 
      end
      for i=1,ownedCount do 
         local n=ownedName[i]
         print(n,lowest[n],highest[n])
         if lowest[n]>3 and highest[n]>3 then 
            onlyRare=onlyRare+1 
         end
         if lowest[n]<4 and highest[n]>3 then 
            nonRareWithRare=nonRareWithRare+1; 
         end
         if highest[n]<4 then nonRare=nonRare+1 end
      end
      for i=1,battlePetOwnedCount do 
         local n=battlePetOwnedName[i]
         if battlePetLowest[n]>3 and battlePetHighest[n]>3 then 
            battlePetOnlyRare=battlePetOnlyRare+1 
         end
         if battlePetLowest[n]<4 and battlePetHighest[n]>3 then 
            battlePetNonRareWithRare=battlePetNonRareWithRare+1; 
         end
         if highest[n]<4 then battlePetNonRare=battlePetNonRare+1 end
      end
   end if msg=="help" then 
      print("Usage:")
      print("Display all tallies: /pettally")
      print("Help: /pettally help")
      print("")
      print("List the pets shown in the tallies:")
      print("/pettally [all | battle] [rare | nonrare | nonswithrares | both]")
      return 
   else
      C_PetJournal.AddAllPetSourcesFilter(true)
      C_PetJournal.AddAllPetTypesFilter(true)
      C_PetJournal.ClearSearchFilter(true)
      GetTotals()
   end
   if not msg or msg=="" then
      for i=1,13 do 
         tallyLabels[i]:SetText(" ")
      end
      tallyLabels[1]:SetText("Total Counts:")
      tallyLabels[2]:SetText("Total Pets Owned:              "..totalCount)
      tallyLabels[3]:SetText("Unowned Pet Types:           "..unownedCount)
      tallyLabels[4]:SetText("Owned Pet Types:               "..ownedCount)
      tallyLabels[5]:SetText("Owned Pets Not Rare:         "..nonRare)
      tallyLabels[6]:SetText("Owned Rare Only Pets:       "..onlyRare)
      tallyLabels[7]:SetText("Owned Rares with Non:      "..nonRareWithRare)
      tallyLabels[8]:SetText("Battle Pet Counts:")
      tallyLabels[9]:SetText("Battle Pets Unowned:           "..petBattleUnowned)
      tallyLabels[10]:SetText("Battle Pet Types Owned:     "..battlePetOwnedCount)
      tallyLabels[11]:SetText("Battle Pets Not Rare:        "..battlePetNonRare)
      tallyLabels[12]:SetText("Battle Pets Rare Only:      "..battlePetOnlyRare)
      tallyLabels[13]:SetText("Battle Pets Rare with Non: "..battlePetNonRareWithRare)
   else
      local source, filter = msg:match("^(%S*)%s*(.-)$");
      source = strlower(source)
      filter=strlower(filter)
      if filter == "unowned" then
         print("source: "..source)
         print("filter: "..filter)
         if source == "all" then
            for i=1,unownedCount do 
               print(unownedName[i])
            end
         end
         if source == "battle" then
            print(petBattleUnowned)
            for i=1,petBattleUnowned do 
               print(unownedBattlePetName[i])
            end
         end
      else
         if source=="all" then 
            for i=1,ownedCount do 
               local n=ownedName[i]
               local data=owned[n].." "..color[highest[n]]..ownedName[i].."|r"
               if lowest[n]>3 and highest[n]>3 and (filter=="rare") then 
                  --print(ownedName[i])
                  --print(data)
                  print("("..owned[ownedName[i]]..") "..allLinks[i])
               end
               if lowest[n]<4 and highest[n]>3 and (filter=="nonswithrares" or filter=="both") then 
                  if highest[n] ~= lowest[n] then print(owned[n].." "..color[lowest[n]]..ownedName[i].."|r") end
                  --print(data)
                  print(allLinks[i])
               end
               if highest[n]<4 and (filter=="nonrare" or filter=="both") then 
                  --print(data)
                  print(allLinks[i])
               end
            end
         end
         if source=="battle" then 
            for i=1,battlePetOwnedCount do 
               local n=battlePetOwnedName[i]
               local data=battlePetOwned[n].." "..color[battlePetHighest[n]]..battlePetOwnedName[i].."|r"
               if battlePetLowest[n]>3 and battlePetHighest[n]>3 and (filter=="rare") then 
                  --print(data)
                  print("("..battlePetOwned[battlePetOwnedName[i]]..") "..battlePetLinks[i])
               end
               if battlePetLowest[n]<4 and battlePetHighest[n]>3 and (filter=="nonswithrares" or filter=="both") then 
                  print(battlePetOwned[n].." "..color[battlePetLowest[n]]..battlePetOwnedName[i].."|r")
                  --print(data)
                  print(battlePetLinks[i])
               end
               if highest[n]<4 and (filter=="nonrare" or filter=="both") then
                  --print(data)
                  print(battlePetLinks[i])
               end
            end
         end 
      end
   end
end
function MBPNtally:UpdateTally() 
   if MBPNtally.IsVisible == true then PrintTally() end
end
MBPNCtally:RegisterChatCommand("tally","PrintTotals")
MBPNtally:RegisterEvent("PET_JOURNAL_LIST_UPDATE","UpdateTally")